## scitokens-cpp 1.1.1

=== vendor/jwt-cpp/tests/CMakeLists.txt ===
if(JWT_DISABLE_BASE64)
  message(FATAL_ERROR "Tests requires the base64 support to be enabled!")
endif()

if(JWT_DISABLE_PICOJSON)
  message(FATAL_ERROR "Tests requires the picojson support to be enabled!")
endif()

enable_testing()
include(GoogleTest)
if(HUNTER_ENABLED)
  hunter_add_package(GTest)
endif()
find_package(GTest REQUIRED)

set(TEST_SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/BaseTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/ClaimTest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Keys.cpp ${CMAKE_CURRENT_SOURCE_DIR}/HelperTest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/TestMain.cpp ${CMAKE_CURRENT_SOURCE_DIR}/TokenFormatTest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/TokenTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/JwksTest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/OpenSSLErrorTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/traits/NlohmannTest.cpp)

find_package(jsoncons CONFIG)
if(TARGET jsoncons)
  list(APPEND TEST_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/traits/JsonconsTest.cpp)
endif()

include("private-find-boost-json")
if(TARGET boost_json)
  list(APPEND TEST_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/traits/BoostJsonTest.cpp)
endif()

add_executable(jwt-cpp-test ${TEST_SOURCES})

# NOTE: Don't use space inside a generator expression here, because the function prematurely breaks the expression into
# multiple lines. https://cmake.org/pipermail/cmake/2018-April/067422.html
set(JWT_TESTER_GCC_FLAGS -Wall -Wextra -Wpedantic)
set(JWT_TESTER_CLANG_FLAGS -Weverything -Wno-c++98-compat -Wno-global-constructors -Wno-weak-vtables)
target_compile_options(
  jwt-cpp-test PRIVATE $<$<CXX_COMPILER_ID:MSVC>:/W4> $<$<CXX_COMPILER_ID:GNU>:${JWT_TESTER_GCC_FLAGS}>
                       $<$<CXX_COMPILER_ID:Clang>:${JWT_TESTER_CLANG_FLAGS}>)
if(HUNTER_ENABLED)
  target_link_libraries(jwt-cpp-test PRIVATE GTest::gtest GTest::gtest_main)
  # Define a compile define to bypass openssl error tests
  target_compile_definitions(jwt-cpp-test PRIVATE HUNTER_ENABLED=1)
else()
  target_link_libraries(jwt-cpp-test PRIVATE GTest::GTest GTest::Main)
  if(TARGET jsoncons)
    target_link_libraries(jwt-cpp-test PRIVATE jsoncons)
  endif()
  if(TARGET boost_json)
    target_link_libraries(jwt-cpp-test PRIVATE boost_json)
  endif()
endif()
target_link_libraries(jwt-cpp-test PRIVATE jwt-cpp $<$<NOT:$<CXX_COMPILER_ID:MSVC>>:${CMAKE_DL_LIBS}>)

gtest_add_tests(TARGET jwt-cpp-test)

if(JWT_ENABLE_COVERAGE)
  include("code-coverage")
  setup_coverage(jwt-cpp-test)
  set(COVERAGE_EXCLUDES "/usr/**" "/home/*/.conan/**" "*test*" "*build*" "**/nlohmann/json.hpp"
                        "**/picojson/picojson.h" "*boost*" "*jsoncons*")
  setup_target_for_coverage_lcov(NAME coverage EXECUTABLE ${CMAKE_CURRENT_BINARY_DIR}/jwt-cpp-test)
endif()

=== debian/changelog ===
scitokens-cpp (1.1.1-1) stable; urgency=medium

  [ Derek Weitzel ]
  * Improve error handling around the sqlite3 library
  * Fix test failures and compiler warnings

 -- root <htcondor-admin@cs.wisc.edu>  Tue, 05 Mar 2024 20:08:24 +0000

=== debian/control ===
Source: scitokens-cpp
Section: net
Priority: optional
Standards-Version: 4.6.2
Build-Depends:
 debhelper-compat (= 13),
 dpkg-dev (>= 1.22.5),
 cmake,
 pkgconf,
 libcurl4-openssl-dev,
 libsqlite3-dev,
 libssl-dev,
 uuid-dev,
 libgtest-dev
Homepage: https://github.com/scitokens/scitokens-cpp
Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
Vcs-Browser: https://salsa.debian.org/ellert/scitokens-cpp
Vcs-Git: https://salsa.debian.org/ellert/scitokens-cpp.git

Package: libscitokens0t64
Provides: ${t64:Provides}
Replaces: libscitokens0
Breaks: libscitokens0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: C++ Implementation of the SciTokens Library
 This package implements a minimal library for creating and using
 SciTokens from C or C++.
 .
 SciTokens (https://scitokens.org) provide a token format for
 distributed authorization. The tokens are self-describing, can be
 verified in a distributed fashion (no need to contact the issuer to
 determine if the token is valid). This is convenient for a federated
 environment where several otherwise-independent storage endpoints
 want to delegate trust for an issuer for managing a storage
 allocation.

Package: libscitokens-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libscitokens0t64 (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for scitokens-cpp
 Development files (header files) for scitokens-cpp.

Package: scitokens-cpp
Architecture: any
Multi-Arch: foreign
Depends:
 libscitokens0t64 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Binaries for scitokens-cpp
 Binaries for creating, verifying and testing scitokens.

## scitokens-cpp 1.1.2

=== debian/changelog ===
scitokens-cpp (1.1.2-1) stable; urgency=medium

  [ Derek Weitzel ]
  * Turn off CMAKE unity builds
  * Add a mutex around requesting public keys to stop overloading issuers

 -- root <htcondor-admin@cs.wisc.edu>  Tue, 03 Dec 2024 21:22:25 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: scitokens-cpp
 Section: net
 Priority: optional
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Build-Depends:
  debhelper-compat (= 13),
  dpkg-dev (>= 1.22.5),

## scitokens-cpp 1.1.3

=== CMakeLists.txt ===

cmake_minimum_required( VERSION 3.10)

project( scitokens-cpp 
	DESCRIPTION "A C++ Library to interface to scitokens"
	VERSION 1.0.2
	LANGUAGES CXX)

option( SCITOKENS_BUILD_UNITTESTS "Build the scitokens-cpp unit tests" OFF )
option( SCITOKENS_EXTERNAL_GTEST "Use an external/pre-installed copy of GTest" OFF )

set( CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}" )

set( CMAKE_BUILD_TYPE RelWithDebInfo) # -g -O2

set( CMAKE_UNITY_BUILD False)

include(GNUInstallDirs)

find_package( jwt-cpp REQUIRED )
find_package( CURL REQUIRED )
find_package( UUID REQUIRED )

if( APPLE )

find_package( OpenSSL REQUIRED )
find_package( Sqlite3 REQUIRED )
set(LIBCRYPTO_INCLUDE_DIRS ${OPENSSL_INCLUDE_DIR})
set(LIBCRYPTO_LIBRARIES ${OPENSSL_CRYPTO_LIBRARY})
set(CMAKE_MACOSX_RPATH ON)

elseif( UNIX )

include (FindPkgConfig)
pkg_check_modules(LIBCRYPTO REQUIRED libcrypto)
pkg_check_modules(OPENSSL REQUIRED openssl)
pkg_check_modules(SQLITE REQUIRED sqlite3)

endif()

add_library(SciTokens SHARED src/scitokens.cpp src/scitokens_internal.cpp src/scitokens_cache.cpp)
target_compile_features(SciTokens PUBLIC cxx_std_11) # Use at least C++11 for building and when linking to scitokens
target_include_directories(SciTokens PUBLIC ${JWT_CPP_INCLUDES} "${PROJECT_SOURCE_DIR}/src" PRIVATE ${CURL_INCLUDE_DIRS} ${OPENSSL_INCLUDE_DIRS} ${LIBCRYPTO_INCLUDE_DIRS} ${SQLITE_INCLUDE_DIRS}  ${UUID_INCLUDE_DIRS})

target_link_libraries(SciTokens PUBLIC ${OPENSSL_LIBRARIES} ${LIBCRYPTO_LIBRARIES} ${CURL_LIBRARIES} ${SQLITE_LIBRARIES} ${UUID_LIBRARIES})
if (UNIX)
# pkg_check_modules fails to return an absolute path on RHEL7.  Set the
# link directories accordingly.
target_link_directories(SciTokens PUBLIC ${OPENSSL_LIBRARY_DIRS} ${LIBCRYPTO_LIBRARY_DIRS})
endif()

if ( NOT APPLE AND UNIX )
set_target_properties(SciTokens PROPERTIES LINK_FLAGS "-Wl,--version-script=${PROJECT_SOURCE_DIR}/configs/export-symbols")
endif()

add_executable(scitokens-test src/test.cpp)
target_include_directories(scitokens-test PRIVATE "${PROJECT_SOURCE_DIR}" ${JWT_CPP_INCLUDES} ${LIBCRYPTO_INCLUDE_DIRS})
target_link_libraries(scitokens-test SciTokens)

add_executable(scitokens-verify src/verify.cpp)
target_link_libraries(scitokens-verify SciTokens)

add_executable(scitokens-test-access src/test_access.cpp)
target_link_libraries(scitokens-test-access SciTokens)

add_executable(scitokens-list-access src/list_access.cpp)
target_link_libraries(scitokens-list-access SciTokens)

add_executable(scitokens-create src/create.cpp)
target_link_libraries(scitokens-create SciTokens)

get_directory_property(TARGETS BUILDSYSTEM_TARGETS)
install(
  TARGETS ${TARGETS} 
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} )

install(
  FILES src/scitokens.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/scitokens )

set_target_properties(
  SciTokens
  PROPERTIES
  VERSION   "0.0.2"
  SOVERSION "0"
  )

if( SCITOKENS_BUILD_UNITTESTS )
	if( NOT SCITOKENS_EXTERNAL_GTEST )
include(ExternalProject)
ExternalProject_Add(gtest
    PREFIX external/gtest
    URL ${CMAKE_CURRENT_SOURCE_DIR}/vendor/gtest
    INSTALL_COMMAND :
)
endif()
enable_testing()
add_subdirectory(test)
endif()

=== test/CMakeLists.txt ===

add_executable(scitokens-gtest main.cpp)
if( NOT SCITOKENS_EXTERNAL_GTEST )
    add_dependencies(scitokens-gtest gtest)
    include_directories("${PROJECT_SOURCE_DIR}/vendor/gtest/googletest/include")
endif()

if(SCITOKENS_EXTERNAL_GTEST)
    set(LIBGTEST "gtest")
else()
    set(LIBGTEST "${CMAKE_BINARY_DIR}/external/gtest/src/gtest-build/lib/libgtest.a")
endif()

target_link_libraries(scitokens-gtest SciTokens "${LIBGTEST}" pthread)

add_test(
  NAME
    unit
  COMMAND
    ${CMAKE_CURRENT_BINARY_DIR}/scitokens-gtest
  )

=== vendor/jwt-cpp/example/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(jwt-cpp-examples)

if(NOT TARGET jwt-cpp)
  find_package(jwt-cpp CONFIG REQUIRED)
endif()

add_subdirectory(traits)

if(JWT_DISABLE_PICOJSON)
  message(FATAL_ERROR "examples require picojson to be available!")
endif()

add_executable(print-claims print-claims.cpp)
target_link_libraries(print-claims jwt-cpp::jwt-cpp)

add_executable(private-claims private-claims.cpp)
target_link_libraries(private-claims jwt-cpp::jwt-cpp)

add_executable(rsa-create rsa-create.cpp)
target_link_libraries(rsa-create jwt-cpp::jwt-cpp)

add_executable(rsa-verify rsa-verify.cpp)
target_link_libraries(rsa-verify jwt-cpp::jwt-cpp)

add_executable(jwks-verify jwks-verify.cpp)
target_link_libraries(jwks-verify jwt-cpp::jwt-cpp)

add_executable(es256k es256k.cpp)
target_link_libraries(es256k jwt-cpp::jwt-cpp)

=== vendor/jwt-cpp/example/conan/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(conan-example)

include(${CMAKE_BINARY_DIR}/conanbuildinfo.cmake)
conan_basic_setup()

add_executable(${PROJECT_NAME} main.cpp)
target_link_libraries(${PROJECT_NAME} ${CONAN_LIBS})

=== vendor/jwt-cpp/example/traits/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(jwt-cpp-traits)

if(NOT TARGET jwt-cpp)
  find_package(jwt-cpp CONFIG REQUIRED)
endif()

find_package(jsoncons CONFIG)
if(TARGET jsoncons)
  add_executable(danielaparker-jsoncons danielaparker-jsoncons.cpp)
  target_link_libraries(danielaparker-jsoncons jwt-cpp::jwt-cpp jsoncons)
endif()

include("../../cmake/private-find-boost-json.cmake")
if(TARGET boost_json)
  add_executable(boost-json boost-json.cpp)
  target_link_libraries(boost-json jwt-cpp::jwt-cpp boost_json)
endif()

find_package(nlohmann_json CONFIG)
if(TARGET nlohmann_json::nlohmann_json)
add_executable(nlohmann-json nlohmann-json.cpp)
target_link_libraries(nlohmann-json nlohmann_json::nlohmann_json jwt-cpp::jwt-cpp)
endif()

include("../../cmake/private-find-kazuho-picojson.cmake")
if(TARGET kazuho_picojson)
  add_executable(kazuho-picojson kazuho-picojson.cpp)
  target_link_libraries(kazuho-picojson jwt-cpp::jwt-cpp kazuho_picojson)
endif()

=== vendor/jwt-cpp/tests/cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(jwt-cpp-installation-tests)

set(TEST CACHE STRING "The test source file to be used")

find_package(jwt-cpp 0.6.0 EXACT REQUIRED CONFIG)

add_executable(test-project ${TEST}.cpp)
target_link_libraries(test-project jwt-cpp::jwt-cpp)

=== vendor/jwt-cpp/tests/fuzz/CMakeLists.txt ===
if(NOT ${CMAKE_CXX_COMPILER_ID} STREQUAL Clang)
  message(FATAL_ERROR "Fuzzing is only available on Clang")
endif()

function(ADD_FUZZING_EXECUTABLE TARGET)
  add_executable(jwt-cpp-fuzz-${TARGET} "${TARGET}.cpp")
  target_compile_options(
    jwt-cpp-fuzz-${TARGET}
    PRIVATE -g -O1 -fsanitize=fuzzer,address,signed-integer-overflow,undefined
            -fno-omit-frame-pointer)
  target_link_options(
    jwt-cpp-fuzz-${TARGET} PRIVATE
    -fsanitize=fuzzer,address,signed-integer-overflow,undefined
    -fno-omit-frame-pointer)
  target_link_libraries(jwt-cpp-fuzz-${TARGET} PRIVATE jwt-cpp::jwt-cpp)
endfunction()

add_fuzzing_executable(BaseEncodeFuzz)
add_fuzzing_executable(BaseDecodeFuzz)
add_fuzzing_executable(TokenDecodeFuzz)

=== debian/changelog ===
scitokens-cpp (1.1.3-1) stable; urgency=medium

  [ Derek Weitzel ]
  * Include cstdint import for jwt library to support newer compilers

 -- root <htcondor-admin@cs.wisc.edu>  Wed, 09 Apr 2025 16:34:29 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: scitokens-cpp
 Section: net
 Priority: optional
-Standards-Version: 4.7.0
+Standards-Version: 4.7.1
 Build-Depends:
  debhelper-compat (= 13),
  dpkg-dev (>= 1.22.5),

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DSCITOKENS_BUILD_UNITTESTS:BOOL=ON \
	    -DSCITOKENS_EXTERNAL_GTEST:BOOL=ON

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Filter out tests that require network connection
	# Use a key cache directory outside HOME since HOME might not exit
	cd obj-$(DEB_HOST_GNU_TYPE) && \
		GTEST_FILTER=-KeycacheTest.RefreshTest:KeycacheTest.RefreshExpiredTest \
		XDG_CACHE_HOME=$(CURDIR)/.cache \
		ctest --output-on-failure
endif

## scitokens-cpp 1.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,12 +8,18 @@
 
 option( SCITOKENS_BUILD_UNITTESTS "Build the scitokens-cpp unit tests" OFF )
 option( SCITOKENS_EXTERNAL_GTEST "Use an external/pre-installed copy of GTest" OFF )
+option( SCITOKENS_WITH_ASAN       "Build with the address sanitizer" OFF )
 
 set( CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}" )
 
 set( CMAKE_BUILD_TYPE RelWithDebInfo) # -g -O2
 
 set( CMAKE_UNITY_BUILD False)
+
+if( SCITOKENS_WITH_ASAN )
+  add_compile_options(-fsanitize=address -fno-omit-frame-pointer)
+  add_link_options(-fsanitize=address)
+endif()
 
 include(GNUInstallDirs)

=== vendor/jwt-cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)
cmake_policy(VERSION 3.14)
if(POLICY CMP0135) # DOWNLOAD_EXTRACT_TIMESTAMP
  cmake_policy(SET CMP0135 OLD)
endif()

# HUNTER_ENABLED is always set if this package is included in a project using hunter (HunterGate sets it) In this case
# we will use hunter as well to stay consistent. If not the use can supply it on configure to force using hunter.
if(HUNTER_ENABLED)
  include("cmake/HunterGate.cmake")
  huntergate(URL "https://github.com/cpp-pm/hunter/archive/v0.23.314.tar.gz" SHA1
             "95c47c92f68edb091b5d6d18924baabe02a6962a")
  message(STATUS "jwt-cpp: using hunter for dependency resolution")
endif()

project(jwt-cpp LANGUAGES CXX)

option(JWT_BUILD_EXAMPLES "Configure CMake to build examples (or not)" ON)
option(JWT_BUILD_TESTS "Configure CMake to build tests (or not)" OFF)
option(JWT_BUILD_DOCS "Adds a target for building the doxygen documentation" OFF)
option(JWT_ENABLE_COVERAGE "Enable code coverage testing" OFF)
option(JWT_ENABLE_FUZZING "Enable fuzz testing" OFF)

option(JWT_DISABLE_PICOJSON "Do not provide the picojson template specialiaze" OFF)
option(JWT_DISABLE_BASE64 "Do not include the base64 implementation from this library" OFF)
include(CMakeDependentOption)
cmake_dependent_option(JWT_EXTERNAL_PICOJSON
  "Use find_package() to locate picojson, provided to integrate with package managers" OFF
  "NOT JWT_DISABLE_PICOJSON" OFF)
cmake_dependent_option(JWT_EXTERNAL_NLOHMANN_JSON
  "Use find_package() to locate nlohman-json required for tests and examples" OFF
  "JWT_BUILD_EXAMPLES OR JWT_BUILD_TESTS" OFF)

set(JWT_SSL_LIBRARY_OPTIONS OpenSSL LibreSSL wolfSSL)
set(JWT_SSL_LIBRARY OpenSSL CACHE STRING "Determines which SSL library to build with")
set_property(CACHE JWT_SSL_LIBRARY PROPERTY STRINGS ${JWT_SSL_LIBRARY_OPTIONS})

set(JWT_JSON_TRAITS_OPTIONS boost-json danielaparker-jsoncons kazuho-picojson nlohmann-json open-source-parsers-jsoncpp)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

if(NOT JWT_SSL_LIBRARY IN_LIST JWT_SSL_LIBRARY_OPTIONS)
  message(FATAL_ERROR "JWT_SSL_LIBRARY must be one of ${JWT_SSL_LIBRARY_OPTIONS}")
endif()

# If Hunter is enabled, we configure it to resolve OpenSSL and warn the user if he selected an option not supported by
# hunter. We fall back to the system library in this case.
if(HUNTER_ENABLED)
  if(${JWT_SSL_LIBRARY} MATCHES "OpenSSL")
    hunter_add_package(OpenSSL)
  elseif(${JWT_SSL_LIBRARY} MATCHES "LibreSSL")
    message(WARNING "Hunter does not support LibreSSL yet, the system library will be used (if available)")
  elseif(${JWT_SSL_LIBRARY} MATCHES "wolfSSL")
    message(WARNING "Hunter does not support wolfSSL yet, the system library will be used (if available)")
  endif()
  if(JWT_EXTERNAL_PICOJSON)
    message(WARNING "Hunter does not support picojson yet, the system library will be used (if available)")
  endif()
endif()

# Lookup dependencies
if(${JWT_SSL_LIBRARY} MATCHES "OpenSSL")
  find_package(OpenSSL 1.0.1 REQUIRED)
elseif(${JWT_SSL_LIBRARY} MATCHES "LibreSSL")
  find_package(LibreSSL 3.0.0 REQUIRED)
elseif(${JWT_SSL_LIBRARY} MATCHES "wolfSSL")
  find_package(PkgConfig REQUIRED)
  pkg_check_modules(wolfssl REQUIRED IMPORTED_TARGET wolfssl)
  list(TRANSFORM wolfssl_INCLUDE_DIRS APPEND "/wolfssl") # This is required to access OpenSSL compatibility API
endif()

if(NOT JWT_DISABLE_PICOJSON AND JWT_EXTERNAL_PICOJSON)
  find_package(picojson 1.3.0 REQUIRED)
endif()

if(JWT_BUILD_EXAMPLES OR JWT_BUILD_TESTS)
  if(JWT_EXTERNAL_NLOHMANN_JSON)
    message(STATUS "jwt-cpp: using find_package for nlohmann-json required for tests")
    find_package(nlohmann_json CONFIG REQUIRED)
  else()
    message(STATUS "jwt-cpp: using FetchContent for nlohmann-json required for tests")
    include(FetchContent)
    fetchcontent_declare(nlohmann_json
      URL https://github.com/nlohmann/json/releases/download/v3.11.2/json.tar.xz
      URL_MD5 127794b2c82c0c5693805feaa2a703e2)
    fetchcontent_makeavailable(nlohmann_json)
  endif()
endif()

set(JWT_INCLUDE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(JWT_HEADER_FILES ${JWT_INCLUDE_PATH}/jwt-cpp/jwt.h)
foreach(traits ${JWT_JSON_TRAITS_OPTIONS})
  list(APPEND JWT_HEADER_FILES ${JWT_INCLUDE_PATH}/jwt-cpp/traits/${traits}/defaults.h
       ${JWT_INCLUDE_PATH}/jwt-cpp/traits/${traits}/traits.h)
endforeach()

if(NOT JWT_DISABLE_BASE64)
  list(APPEND JWT_HEADER_FILES ${JWT_INCLUDE_PATH}/jwt-cpp/base.h)
endif()

add_library(jwt-cpp INTERFACE)
add_library(jwt-cpp::jwt-cpp ALIAS jwt-cpp) # To match export
target_compile_features(jwt-cpp INTERFACE cxx_std_11)
if(JWT_DISABLE_BASE64)
  target_compile_definitions(jwt-cpp INTERFACE JWT_DISABLE_BASE64)
endif()
if(JWT_DISABLE_PICOJSON)
  target_compile_definitions(jwt-cpp INTERFACE JWT_DISABLE_PICOJSON)
endif()

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
target_include_directories(jwt-cpp INTERFACE $<BUILD_INTERFACE:${JWT_INCLUDE_PATH}>
                                             $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

if(${JWT_SSL_LIBRARY} MATCHES "OpenSSL")
  target_link_libraries(jwt-cpp INTERFACE OpenSSL::SSL OpenSSL::Crypto)
endif()

if(${JWT_SSL_LIBRARY} MATCHES "LibreSSL")
  target_link_libraries(jwt-cpp INTERFACE LibreSSL::TLS)
endif()

if(${JWT_SSL_LIBRARY} MATCHES "wolfSSL")
  target_link_libraries(jwt-cpp INTERFACE PkgConfig::wolfssl)
  # This is required to access OpenSSL compatibility API
  target_include_directories(jwt-cpp INTERFACE ${wolfssl_INCLUDE_DIRS})
  # This flag is required to have the mandatory header included automatically 
  # https://github.com/Thalhammer/jwt-cpp/pull/352#discussion_r1627971786
  # https://github.com/wolfSSL/wolfssl/blob/3b74a6402998a8b8839e25e31ba8ac74749aa9b0/wolfssl/wolfcrypt/settings.h#L58
  target_compile_definitions(jwt-cpp INTERFACE EXTERNAL_OPTS_OPENVPN)
endif()

if(NOT JWT_DISABLE_PICOJSON AND JWT_EXTERNAL_PICOJSON)
  target_link_libraries(jwt-cpp INTERFACE picojson::picojson>)
endif()

# Hunter needs relative paths so the files are placed correctly
if(NOT JWT_CMAKE_FILES_INSTALL_DIR)
  set(JWT_CMAKE_FILES_INSTALL_DIR cmake)
endif()

configure_package_config_file(
  ${CMAKE_CURRENT_LIST_DIR}/cmake/jwt-cpp-config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/jwt-cpp-config.cmake
  INSTALL_DESTINATION ${JWT_CMAKE_FILES_INSTALL_DIR})
write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/jwt-cpp-config-version.cmake VERSION 0.7.1
                                 COMPATIBILITY ExactVersion)

install(TARGETS jwt-cpp EXPORT jwt-cpp-targets PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(EXPORT jwt-cpp-targets NAMESPACE jwt-cpp:: FILE jwt-cpp-targets.cmake
        DESTINATION ${JWT_CMAKE_FILES_INSTALL_DIR})
install(DIRECTORY ${JWT_INCLUDE_PATH}/jwt-cpp DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
if(NOT JWT_EXTERNAL_PICOJSON AND NOT JWT_DISABLE_PICOJSON)
  install(FILES ${JWT_INCLUDE_PATH}/picojson/picojson.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/picojson)
endif()
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/jwt-cpp-config.cmake ${CMAKE_CURRENT_BINARY_DIR}/jwt-cpp-config-version.cmake
        DESTINATION ${JWT_CMAKE_FILES_INSTALL_DIR})

if(JWT_BUILD_EXAMPLES)
  add_subdirectory(example)
endif()

if(JWT_BUILD_TESTS)
  enable_testing()
  add_subdirectory(tests)
endif()

if(JWT_ENABLE_FUZZING)
  add_subdirectory(tests/fuzz)
endif()

if(JWT_BUILD_DOCS)
  add_subdirectory(docs)
endif()

=== debian/changelog ===
scitokens-cpp (1.2.0-1) unstable; urgency=medium

  * Update to version 1.2.0

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Wed, 10 Dec 2025 10:13:25 +0100

scitokens-cpp (1.1.3-1) unstable; urgency=medium

  * Update to version 1.1.3
  * Drop patch accepted upstream

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 25 Feb 2025 16:10:56 +0100

scitokens-cpp (1.1.2-2) unstable; urgency=medium

  * Fix compilation with GCC 15 (Closes: #1097859)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sat, 22 Feb 2025 15:14:43 +0100

scitokens-cpp (1.1.2-1) unstable; urgency=medium

  * Update to version 1.1.2

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Fri, 01 Nov 2024 10:42:21 +0100

scitokens-cpp (1.1.1-1) unstable; urgency=medium

  * Update to version 1.1.1
  * Drop patch accepted upstream

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Fri, 15 Mar 2024 08:26:19 +0100

scitokens-cpp (1.1.0-2) unstable; urgency=medium

  * Correct expected package name in lintian override

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sun, 10 Mar 2024 14:59:00 +0100

scitokens-cpp (1.1.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062887

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 15:44:22 +0000

scitokens-cpp (1.1.0-1) unstable; urgency=medium

  * Update to version 1.1.0

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Fri, 10 Nov 2023 14:35:19 +0100

scitokens-cpp (1.0.2-1) unstable; urgency=medium

  * Update to version 1.0.2
  * Drop patch accepted upstream
  * Fix test failures and compiler warnings

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Fri, 16 Jun 2023 09:03:15 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: scitokens-cpp
 Section: net
 Priority: optional
-Standards-Version: 4.7.1
+Standards-Version: 4.7.2
 Build-Depends:
  debhelper-compat (= 13),
  dpkg-dev (>= 1.22.5),

## scitokens-cpp 1.3.0

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?= 
SPHINXBUILD  ?= sphinx-build
SOURCEDIR    = .
BUILDDIR     = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== docs/requirements.txt ===
sphinx>=4.0
breathe>=4.30
sphinx-rtd-theme>=1.0

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -19,3 +19,82 @@
   COMMAND
     ${CMAKE_CURRENT_BINARY_DIR}/scitokens-gtest
   )
+
+# Environment variable configuration test executable
+add_executable(scitokens-env-test test_env_config.cpp)
+target_link_libraries(scitokens-env-test SciTokens)
+
+# Environment variable configuration test
+add_test(
+  NAME
+    env_config
+  COMMAND
+    ${CMAKE_CURRENT_BINARY_DIR}/scitokens-env-test
+)
+
+set_tests_properties(env_config
+  PROPERTIES
+    ENVIRONMENT "SCITOKEN_CONFIG_KEYCACHE_UPDATE_INTERVAL_S=1234;SCITOKEN_CONFIG_KEYCACHE_EXPIRATION_INTERVAL_S=5678;SCITOKEN_CONFIG_KEYCACHE_CACHE_HOME=/tmp/test_scitoken_cache;SCITOKEN_CONFIG_TLS_CA_FILE=/tmp/test_ca.pem"
+)
+# Monitoring unit tests
+add_executable(scitokens-monitoring-test monitoring_test.cpp)
+if( NOT SCITOKENS_EXTERNAL_GTEST )
+    add_dependencies(scitokens-monitoring-test gtest)
+endif()
+target_link_libraries(scitokens-monitoring-test SciTokens "${LIBGTEST}" pthread)
+
+add_test(
+  NAME
+    monitoring
+  COMMAND
+    ${CMAKE_CURRENT_BINARY_DIR}/scitokens-monitoring-test
+  )
+
+# Integration test executable
+add_executable(scitokens-integration-test integration_test.cpp)
+if( NOT SCITOKENS_EXTERNAL_GTEST )
+    add_dependencies(scitokens-integration-test gtest)
+endif()
+target_link_libraries(scitokens-integration-test SciTokens "${LIBGTEST}" pthread)
+
+# Integration test fixture - setup
+add_test(
+  NAME
+    integration::setup
+  COMMAND
+    ${CMAKE_CURRENT_SOURCE_DIR}/integration-test-setup.sh integration
+)
+
+set_tests_properties(integration::setup
+  PROPERTIES
+    FIXTURES_SETUP integration
+    ENVIRONMENT "BINARY_DIR=${CMAKE_BINARY_DIR};SOURCE_DIR=${PROJECT_SOURCE_DIR}"
+)
+
+# Integration test fixture - teardown
+add_test(
+  NAME
+    integration::teardown
+  COMMAND
+    ${CMAKE_CURRENT_SOURCE_DIR}/integration-test-teardown.sh integration
+)
+
+set_tests_properties(integration::teardown
+  PROPERTIES
+    FIXTURES_CLEANUP integration
+    ENVIRONMENT "BINARY_DIR=${CMAKE_BINARY_DIR}"
+)
+
+# Integration test
+add_test(
+  NAME
+    integration::test
+  COMMAND
+    ${CMAKE_CURRENT_BINARY_DIR}/scitokens-integration-test
+)
+
+set_tests_properties(integration::test
+  PROPERTIES
+    FIXTURES_REQUIRED integration
+    ENVIRONMENT "BINARY_DIR=${CMAKE_BINARY_DIR};CURL_CA_BUNDLE=${CMAKE_BINARY_DIR}/tests/integration/current/ca-cert.pem"
+)

=== debian/changelog ===
scitokens-cpp (1.3.0-2) unstable; urgency=medium

  * Check if libatomic is needed

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sat, 31 Jan 2026 08:21:50 +0100

scitokens-cpp (1.3.0-1) unstable; urgency=medium

  * Update to version 1.3.0

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Fri, 30 Jan 2026 06:38:55 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

%:
	dh $@

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_configure:
	dh_auto_configure -- \
	    -DSCITOKENS_BUILD_UNITTESTS:BOOL=ON \
	    -DSCITOKENS_EXTERNAL_GTEST:BOOL=ON
endif

override_dh_auto_test:
	# Filter out tests that require network connection
	# Use a key cache directory outside HOME since HOME might not exit
	dh_auto_test -- \
		GTEST_FILTER=-KeycacheTest.RefreshTest:KeycacheTest.RefreshExpiredTest:KeycacheTest.NegativeCacheTest:KeycacheTest.LoadJwksTriggersRefreshWhenStale \
		XDG_CACHE_HOME=$(CURDIR)/.cache

## scitokens-cpp 1.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 project( scitokens-cpp 
 	DESCRIPTION "A C++ Library to interface to scitokens"
-	VERSION 1.0.2
+	VERSION 1.4.0
 	LANGUAGES CXX)
 
 option( SCITOKENS_BUILD_UNITTESTS "Build the scitokens-cpp unit tests" OFF )
@@ -44,11 +44,14 @@
 
 endif()
 
-add_library(SciTokens SHARED src/scitokens.cpp src/scitokens_internal.cpp src/scitokens_cache.cpp)
+add_library(SciTokens SHARED src/scitokens.cpp src/scitokens_internal.cpp src/scitokens_cache.cpp src/scitokens_monitoring.cpp)
 target_compile_features(SciTokens PUBLIC cxx_std_11) # Use at least C++11 for building and when linking to scitokens
 target_include_directories(SciTokens PUBLIC ${JWT_CPP_INCLUDES} "${PROJECT_SOURCE_DIR}/src" PRIVATE ${CURL_INCLUDE_DIRS} ${OPENSSL_INCLUDE_DIRS} ${LIBCRYPTO_INCLUDE_DIRS} ${SQLITE_INCLUDE_DIRS}  ${UUID_INCLUDE_DIRS})
 
-target_link_libraries(SciTokens PUBLIC ${OPENSSL_LIBRARIES} ${LIBCRYPTO_LIBRARIES} ${CURL_LIBRARIES} ${SQLITE_LIBRARIES} ${UUID_LIBRARIES})
+# Find threading library
+find_package(Threads REQUIRED)
+
+target_link_libraries(SciTokens PUBLIC ${OPENSSL_LIBRARIES} ${LIBCRYPTO_LIBRARIES} ${CURL_LIBRARIES} ${SQLITE_LIBRARIES} ${UUID_LIBRARIES} Threads::Threads)
 if (UNIX)
 # pkg_check_modules fails to return an absolute path on RHEL7.  Set the
 # link directories accordingly.
@@ -75,6 +78,11 @@
 add_executable(scitokens-create src/create.cpp)
 target_link_libraries(scitokens-create SciTokens)
 
+
+add_executable(scitokens-generate-jwks src/generate_jwks.cpp)
+target_include_directories(scitokens-generate-jwks PRIVATE ${OPENSSL_INCLUDE_DIRS} ${LIBCRYPTO_INCLUDE_DIRS})
+target_link_libraries(scitokens-generate-jwks ${OPENSSL_LIBRARIES} ${LIBCRYPTO_LIBRARIES})
+
 get_directory_property(TARGETS BUILDSYSTEM_TARGETS)
 install(
   TARGETS ${TARGETS} 
@@ -88,7 +96,7 @@
 set_target_properties(
   SciTokens
   PROPERTIES
-  VERSION   "0.0.2"
+  VERSION   "0.0.3"
   SOVERSION "0"
   )

=== debian/changelog ===
scitokens-cpp (1.4.0-1) unstable; urgency=medium

  * Update to version 1.4.0
  * Avoid PATH_MAX (non-portable)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 24 Feb 2026 15:19:47 +0100
